    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * BasicStrokeObjectDescription.java
    029     * ---------------------------------
    030     * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031     *
    032     * Original Author:  Thomas Morgner;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * $Id: BasicStrokeObjectDescription.java,v 1.3 2005/11/14 10:59:02 mungady Exp $
    036     *
    037     * Changes (from 19-Feb-2003)
    038     * -------------------------
    039     * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040     * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041     *
    042     */
    043
    044    package org.jfree.xml.factory.objects;
    045
    046    import java.awt.BasicStroke;
    047
    048    /**
    049     * An object-description for a <code>BasicStroke</code> object.
    050     *
    051     * @author Thomas Morgner
    052     */
    053    public class BasicStrokeObjectDescription extends AbstractObjectDescription {
    054
    055        /**
    056         * Creates a new object description.
    057         */
    058        public BasicStrokeObjectDescription() {
    059            super(BasicStroke.class);
    060            setParameterDefinition("value", String.class);
    061        }
    062
    063        /**
    064         * Returns a parameter as a float.
    065         *
    066         * @param param  the parameter name.
    067         *
    068         * @return The float value.
    069         */
    070        private float getFloatParameter(final String param) {
    071            final String p = (String) getParameter(param);
    072            if (p == null) {
    073                return 0;
    074            }
    075            try {
    076                return Float.parseFloat(p);
    077            }
    078            catch (Exception e) {
    079                return 0;
    080            }
    081        }
    082
    083        /**
    084         * Creates a new <code>BasicStroke</code> object based on this description.
    085         *
    086         * @return The <code>BasicStroke</code> object.
    087         */
    088        public Object createObject() {
    089            final float width = getFloatParameter("value");
    090            return new BasicStroke(width);
    091        }
    092
    093        /**
    094         * Sets the parameters for this description to match the supplied object.
    095         *
    096         * @param o  the object (instance of <code>BasicStroke</code> required).
    097         *
    098         * @throws ObjectFactoryException if the supplied object is not an instance of
    099         *         <code>BasicStroke</code>.
    100         */
    101        public void setParameterFromObject(final Object o) throws ObjectFactoryException {
    102            if (!(o instanceof BasicStroke)) {
    103                throw new ObjectFactoryException("Expected object of type BasicStroke");
    104            }
    105            final BasicStroke bs = (BasicStroke) o;
    106            setParameter("value", String.valueOf(bs.getLineWidth()));
    107        }
    108    }